#include "main.h"
#include <stdlib.h>
#include <stdbool.h>

struct my_lock {
	bool busy;
	int owner;
};

struct my_lock *my_lock_create(void) {
	struct my_lock *l = malloc(sizeof(struct my_lock));

	l->busy = false;
	l->owner = -1;

	return l;
}

void my_lock_destroy(struct my_lock *l) {
	free(l);
}

void my_lock_acquire(struct my_lock *l, int tid) {
	while (l->busy)
		; /* busy wait */

	l->busy = true;
	l->owner = tid;
}

void my_lock_release(struct my_lock *l, int) {
	l->owner = -1;
	l->busy = false;
}
