#include "main.h"
#include "wrap/synch.h"
#include <stdlib.h>

struct my_lock {
	bool busy;
	int owner;

	struct lock lock;
	struct condition cond;
};

struct my_lock *my_lock_create(void) {
	struct my_lock *l = malloc(sizeof(struct my_lock));

	l->busy = false;
	l->owner = -1;

	lock_init(&l->lock);
	cond_init(&l->cond);

	return l;
}

void my_lock_destroy(struct my_lock *l) {
	free(l);
}

void my_lock_acquire(struct my_lock *l, int tid) {
	lock_acquire(&l->lock);
	while (l->busy)
		cond_wait(&l->cond, &l->lock);

	l->busy = true;
	l->owner = tid;
	lock_release(&l->lock);
}

void my_lock_release(struct my_lock *l, int) {
	lock_acquire(&l->lock);
	l->owner = -1;
	l->busy = false;
	cond_signal(&l->cond, &l->lock);
	lock_release(&l->lock);
}
