#pragma once

/**
 * This file contains the lock functions that the code in main.c uses to
 * synchronize itself.
 */

// A lock.
struct my_lock;

// Allocate a lock.
struct my_lock *my_lock_create(void);

// Destroy a lock.
void my_lock_destroy(struct my_lock *lock);

// Acquire the lock.
void my_lock_acquire(struct my_lock *lock, int thread_id);

// Release the lock.
void my_lock_release(struct my_lock *lock, int thread_id);
