#include "wrap/thread.h"
#include "wrap/synch.h"
#include "wrap/timer.h"
#include <stdlib.h>
#include <stdio.h>

int *buffer;
int size;
int sum = 0;

struct semaphore has_low;
struct semaphore has_high;

static void sum_low(void *p) {
	int i;
	UNUSED(p);
	for (i = 0; i < size / 2; ++i)
		sum += buffer[i];
	sema_up(&has_low);
}

static void sum_high(void *p) {
	int i;
	UNUSED(p);
	for (i = size / 2; i < size; ++i)
		sum += buffer[i];
	sema_up(&has_high);
}

int main(int argc, char *argv[]) {
	int i;
	int64_t start;
	double time;

	size = 2000000;
	if (argc >= 2)
		size = atoi(argv[1]);

	buffer = malloc(sizeof(*buffer)*size);
	for (i = 0; i < size; ++i)
		buffer[i] = 1;

	sema_init(&has_low, 0);
	sema_init(&has_high, 0);

	start = timer_ticks();

	thread_create("", 0, &sum_low, NULL);
	thread_create("", 0, &sum_high, NULL);

	sema_down(&has_low);
	sema_down(&has_high);

	time = timer_elapsed(start);

	printf("** The size is %d\n", size);
	printf("And the sum is %d\n", sum);
	printf("  Completed in %.2f ms\n", time);

	return 0;
}
