#include "wrap/thread.h"
#include "wrap/synch.h"
#include "wrap/timer.h"
#include <stdlib.h>
#include <stdio.h>

int *buffer;
int size;
int sum = 0;
int suml = 0;
int sumh = 0;
struct semaphore has_suml;
struct semaphore has_sumh;

static void sum_low(void *p) {
	int i;
	UNUSED(p);
	for (i = 0; i < size / 2; ++i)
		suml += buffer[i];
	sema_up(&has_suml);
}

static void sum_high(void *p) {
	int i;
	UNUSED(p);
	for (i = size / 2; i < size; ++i)
		sumh += buffer[i];
	sema_up(&has_sumh);
}

int main(int argc, char *argv[]) {
	int i;
	int64_t start;
	double time;

	size = 2000000;
	if (argc >= 2)
		size = atoi(argv[1]);

	buffer = malloc(sizeof(*buffer)*size);
	for (i = 0; i < size; ++i)
		buffer[i] = 1;

	start = timer_ticks();

	sema_init(&has_suml, 0);
	sema_init(&has_sumh, 0);

	thread_create("", 0, &sum_low, NULL);
	thread_create("", 0, &sum_high, NULL);

	sema_down(&has_suml);
	sema_down(&has_sumh);

	sum = suml + sumh;

	time = timer_elapsed(start);

	printf("** The size is %d\n", size);
	printf("And the sum is %d\n", sum);
	printf("  Completed in %.2f ms\n", time);

	return 0;
}
