#pragma once
#include "os.h"

typedef void thread_func(void *aux);
tid_t thread_create(const char *name, int priority, thread_func *fn, void *aux);

#if 0
// Same as above, but simpler.
tid_t thread_new(thread_func *fn, void *aux);
#endif

// "thread_new" implemented with macros, so that we can pass any type to the function (just like in Progvis).
#define thread_new(fn, aux) thread_create("", 0, (thread_func *)(fn), aux)

tid_t thread_current(void);
void thread_exit(void);
void thread_yield(void);

void timer_msleep(unsigned milliseconds);
